
package cn.orionsec.ops.handler.importer.impl;

import cn.orionsec.kit.lang.utils.Exceptions;
import cn.orionsec.ops.constant.ImportType;
import cn.orionsec.ops.entity.importer.DataImportDTO;


public interface IDataImporter {

    /**
     * 执行导入
     */
    void doImport();

    /**
     * 创建数据导入器
     *
     * @param importData importData
     * @return importer
     */
    static IDataImporter create(DataImportDTO importData) {
        switch (ImportType.of(importData.getType())) {
            case MACHINE_INFO:
                return new MachineInfoDataImporter(importData);
            case MACHINE_PROXY:
                return new MachineProxyDataImporter(importData);
            case TAIL_FILE:
                return new TailFileDataImporter(importData);
            case APP_PROFILE:
                return new AppProfileDataImporter(importData);
            case APPLICATION:
                return new ApplicationDataImporter(importData);
            case APP_REPOSITORY:
                return new AppRepositoryDataImporter(importData);
            case COMMAND_TEMPLATE:
                return new CommandTemplateDataImporter(importData);
            case WEBHOOK:
                return new WebhookDataImporter(importData);
            default:
                throw Exceptions.unsupported();
        }
    }

}
